// --------------------- interface functions ---------------------
// checksum = 11023


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_stub_EDF.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_GET_MISSED_DEADLINES       _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_GET_EXCEEDED_TIMESLICE     _IOW(BOSSA_ID_NUM, 1, int)
#define IOCTL_SCHED_YIELD                _IOW(BOSSA_ID_NUM, 2, int)
#define IOCTL_ATTACH                     _IOW(BOSSA_ID_NUM, 255, int)
#define BOSSA_DEVICE_NAME "bossa_EDF"


struct dev_EDF_get_missed_deadlines_struct {
  int p;
};

struct dev_EDF_get_exceeded_timeslice_struct {
  int p;
};

struct dev_EDF_sched_yield_struct {
  int p;
};

struct dev_EDF_attach_struct {
  int _checksum;
  int p_9;
  int wcet_10;
  int period_11;
};

int EDF_get_missed_deadlines(int p) {
  struct dev_EDF_get_missed_deadlines_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_GET_MISSED_DEADLINES,(char *)&_data);
    if (res < 0) perror("get_missed_deadlines");
    close(fd);
    return res;
  }
}

int EDF_get_exceeded_timeslice(int p) {
  struct dev_EDF_get_exceeded_timeslice_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_GET_EXCEEDED_TIMESLICE,(char *)&_data);
    if (res < 0) perror("get_exceeded_timeslice");
    close(fd);
    return res;
  }
}

int EDF_sched_yield(int p) {
  struct dev_EDF_sched_yield_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SCHED_YIELD,(char *)&_data);
    if (res) perror("sched_yield");
    close(fd);
    return res;
  }
}

int EDF_attach(int p_9, int wcet_10, int period_11) {
  struct dev_EDF_attach_struct _data;
  _data._checksum = 11023;
  _data.p_9 = p_9;
  _data.wcet_10 = wcet_10;
  _data.period_11 = period_11;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}
