// --------------------- interface functions ---------------------
// checksum = 21541


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_stub_Linux.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SET_PRIORITY           _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_ATTACH                 _IOW(BOSSA_ID_NUM, 255, int)
#define IOCTL_SCHED_SETSCHEDULER     _IOW(BOSSA_ID_NUM, 1, int)
#define BOSSA_DEVICE_NAME "bossa_Linux"


struct dev_Linux_set_priority_struct {
  int p;
  int niceval;
};

struct dev_Linux_attach_struct {
  int _checksum;
  int p_11;
  enum policy_t policy_12;
  int rt_priority_13;
  int niceval_14;
};

struct dev_Linux_sched_setscheduler_struct {
  int p;
  enum policy_t policy;
  int prio;
};

int Linux_set_priority(int p, int niceval) {
  struct dev_Linux_set_priority_struct _data;
  _data.p = p;
  _data.niceval = niceval;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SET_PRIORITY,(char *)&_data);
    if (res) perror("set_priority");
    close(fd);
    return res;
  }
}

int Linux_attach(int p_11, enum policy_t policy_12, int rt_priority_13,
                 int niceval_14) {
  struct dev_Linux_attach_struct _data;
  _data._checksum = 21541;
  _data.p_11 = p_11;
  _data.policy_12 = policy_12;
  _data.rt_priority_13 = rt_priority_13;
  _data.niceval_14 = niceval_14;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}

int Linux_sched_setscheduler(int p, enum policy_t policy, int prio) {
  struct dev_Linux_sched_setscheduler_struct _data;
  _data.p = p;
  _data.policy = policy;
  _data.prio = prio;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SCHED_SETSCHEDULER,(char *)&_data);
    if (res) perror("sched_setscheduler");
    close(fd);
    return res;
  }
}
