// --------------------- interface functions ---------------------
// checksum = 21541


//needs the shared library libbossa.so obtains by : gcc -shared .../bossa/load.c -o /usr/lib/libbossa.so

using System;
using System.Runtime.InteropServices;
using System.Threading;

public class user_Linux
{


	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_attach_info(int parent);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect(int parent, int child, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect_root(int new_root, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_disconnect(int tgt);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_print(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int scheduler_names(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void load_module(string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int find_scheduler(string b, string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount(string parent_name, string child_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount_root(string new_root_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void unmount(string tgt_name);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int open(
		string filename,
		uint flags);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int ioctl(int d,
		uint requete,
		void* lpInBuffer);
		//int lpCompletionRoutine);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void close(int hFile);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int system(string command);

public static unsafe int install_module(string path) {
	return system("cil2module " + path);
}

	const uint GENERIC_READ  = 0x80000000;
	const uint GENERIC_WRITE = 0x40000000;
	const uint OPEN_EXISTING = 3;
	const uint FILE_FLAG_NO_BUFFERING = 0x20000000;
	//const  int SIZE_INT = System.Runtime.InteropServices.Marshal.SizeOf(0);
	const  int SIZE_INT = 4;
	const uint IOCTL_BASE = (1U << 30) | (BOSSA_ID_NUM << 8) | (SIZE_INT << 16);


	const uint BOSSA_ID_NUM = 0xCE;
	const uint IOCTL_SET_PRIORITY            = IOCTL_BASE | (0 << 0);
	const uint IOCTL_ATTACH                  = IOCTL_BASE | (1 << 0);
	const uint IOCTL_SCHED_SETSCHEDULER      = IOCTL_BASE | (2 << 0);
	private const string _BOSSA_DEVICE_NAME = "bossa_Linux";


public enum policy_t
: int {
  BOSSA_SCHED_FIFO, BOSSA_SCHED_RR, BOSSA_SCHED_OTHER
}



struct dev_Linux_set_priority_struct {
  public int p;
  public int niceval;
};

struct dev_Linux_attach_struct {
  int _checksum;
  public int p_11;
  public policy_t policy_12;
  public int rt_priority_13;
  public int niceval_14;
};

struct dev_Linux_sched_setscheduler_struct {
  public int p;
  public policy_t policy;
  public int prio;
};

public static unsafe int Linux_set_priority(int p, int niceval) {
  dev_Linux_set_priority_struct _data;
  _data.p = p;
  _data.niceval = niceval;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_SET_PRIORITY,&_data);
    if (res!=0) Console.Error.WriteLine("set_priority");
    close(fd);
    return res;
  }
}

public static unsafe int Linux_attach(int p_11, policy_t policy_12,
                                      int rt_priority_13, int niceval_14) {
  dev_Linux_attach_struct _data;
  _data._checksum = 21541;
  _data.p_11 = p_11;
  _data.policy_12 = policy_12;
  _data.rt_priority_13 = rt_priority_13;
  _data.niceval_14 = niceval_14;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_ATTACH,&_data);
    if (res < 0) Console.Error.WriteLine("attach");
    close(fd);
    return res;
  }
}

public static unsafe int Linux_sched_setscheduler(int p, policy_t policy,
                                                  int prio) {
  dev_Linux_sched_setscheduler_struct _data;
  _data.p = p;
  _data.policy = policy;
  _data.prio = prio;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_SCHED_SETSCHEDULER,&_data);
    if (res!=0) Console.Error.WriteLine("sched_setscheduler");
    close(fd);
    return res;
  }
}
}

